import {Body, Controller, Get, HttpCode, HttpStatus, Post, UseGuards} from "@nestjs/common";
import {AdminAuthGuard} from "src/core/guards/admin-auth.guard";
import {Constants} from "src/utils/constants";
import { UpdateHomePagePackageSectionCmsDto } from "./dto/update-home-page-package-section-cms.dto";
import { HomePagePackageSectionCmsService } from "./home-page-package-section-cms.service";

@Controller({path: "home-page-package-section-cms", version: Constants.API_VERSION_1})

export class HomePagePackageSectionCmsController {
    constructor(private readonly service: HomePagePackageSectionCmsService) {
    }

    @Post()
    @HttpCode(HttpStatus.OK)
    @UseGuards(AdminAuthGuard)
    updateOrCreateData(
        @Body() dto: UpdateHomePagePackageSectionCmsDto
    ) {
        return this.service.updateOrCreateData(dto);
    }

    @Get()
    // @UseGuards(AdminAuthGuard)
    findAll() {
        return this.service.findAll();
    }
}
