import { EntityRepository, Repository } from "typeorm";
import { UpdateHomePageComponentUiDto } from "./dto/update-home-page-component-ui.dto";
import { HomePageComponentUi } from "./entities/home-page-component-ui.entity";

@EntityRepository(HomePageComponentUi)
export class HomePageComponentUiRepository extends Repository<HomePageComponentUi> {

  async createEntity(dto: UpdateHomePageComponentUiDto): Promise<HomePageComponentUi | Error> {
    try {
      const entity = this.create({
        backgroundColor: dto.backgroundColor,
        heroTitleColor: dto.heroTitleColor,
        heroButtonTextColor: dto.heroButtonTextColor,
        heroButtonBackgroundColor: dto.heroButtonBackgroundColor,
        heroButtonHoverBackgroundColor: dto.heroButtonHoverBackgroundColor,
        aboutHeadingColor: dto.aboutHeadingColor,
        aboutbuttonTextColor: dto.aboutbuttonTextColor,
        aboutTitleColor: dto.aboutTitleColor,
        aboutbuttonBgColor: dto.aboutbuttonBgColor,
        aboutButtonHoverBgColor: dto.aboutButtonHoverBgColor,
        aboutImageTextOneColor: dto.aboutImageTextOneColor,
        bannerButtonTextColor: dto.bannerButtonTextColor,
        bannerTitleColor: dto.bannerTitleColor,
        bannerButtonBgColor: dto.bannerButtonBgColor,
        ourProductHeadingColor: dto.ourProductHeadingColor,
        ourProductTitleColor: dto.ourProductTitleColor,
        discoverSectionTitleColor: dto.discoverSectionTitleColor,
        discoverSectionBgColor: dto.discoverSectionBgColor,
        packageTitleColor: dto.packageTitleColor,
        packageSubTitleColor: dto.packageSubTitleColor,
        blogHeadingColor: dto.blogHeadingColor,
        blogTitleColor: dto.blogTitleColor,
        testimonialSectionBackgroundColor: dto.testimonialSectionBackgroundColor,
        testimonialTitleColor: dto.testimonialTitleColor,
        testimonialDescriptionColor: dto.testimonialDescriptionColor,
        instagramHeadingColor: dto.instagramHeadingColor,
        instagramTitleColor: dto.instagramTitleColor
      });
      await this.save(entity);
      return entity;
    } catch (e) {
      return e;
    }
  }

  async updateEntity(dto: UpdateHomePageComponentUiDto, id: string): Promise<HomePageComponentUi | Error> {
    try {
      await this.update(id, {
        backgroundColor: dto.backgroundColor,
        heroTitleColor: dto.heroTitleColor,
        heroButtonTextColor: dto.heroButtonTextColor,
        heroButtonBackgroundColor: dto.heroButtonBackgroundColor,
        heroButtonHoverBackgroundColor: dto.heroButtonHoverBackgroundColor,
        aboutHeadingColor: dto.aboutHeadingColor,
        aboutbuttonTextColor: dto.aboutbuttonTextColor,
        aboutTitleColor: dto.aboutTitleColor,
        aboutbuttonBgColor: dto.aboutbuttonBgColor,
        aboutButtonHoverBgColor: dto.aboutButtonHoverBgColor,
        aboutImageTextOneColor: dto.aboutImageTextOneColor,
        bannerButtonTextColor: dto.bannerButtonTextColor,
        bannerTitleColor: dto.bannerTitleColor,
        bannerButtonBgColor: dto.bannerButtonBgColor,
        ourProductHeadingColor: dto.ourProductHeadingColor,
        ourProductTitleColor: dto.ourProductTitleColor,
        discoverSectionTitleColor: dto.discoverSectionTitleColor,
        discoverSectionBgColor: dto.discoverSectionBgColor,
        packageTitleColor: dto.packageTitleColor,
        packageSubTitleColor: dto.packageSubTitleColor,
        blogHeadingColor: dto.blogHeadingColor,
        blogTitleColor: dto.blogTitleColor,
        testimonialSectionBackgroundColor: dto.testimonialSectionBackgroundColor,
        testimonialTitleColor: dto.testimonialTitleColor,
        testimonialDescriptionColor: dto.testimonialDescriptionColor,
        instagramHeadingColor: dto.instagramHeadingColor,
        instagramTitleColor: dto.instagramTitleColor
      });
      return await this.findOne(id);
    } catch (e) {
      return e;
    }
  }

  async findAll(): Promise<HomePageComponentUi[] | Error> {
    try {
      return await this.find({
        where: {
          isDeleted: false
        }
      });
    } catch (e) {
      return e;
    }
  }
}