import { Module } from "@nestjs/common";
import { JwtModule } from "@nestjs/jwt";
import { TypeOrmModule } from "@nestjs/typeorm";
import JwtConfigService from "src/core/jwt/jwt-config.service";
import JwtHelper from "src/core/jwt/jwt.helper";
import { UsersRepository } from "src/modules/users/user.repository";
import { DoSpacesServicerovider } from "../../SpacesModule/SpacesService";
import { DoSpacesService } from "../../SpacesModule/SpacesService/doSpacesService";
import { ProductOffersRepository } from "./product-offers.repository";
import { ProductOffersController } from "./product-offers.controller";
import { ProductOffersService } from "./product-offers.service";

@Module({
    imports: [
        JwtModule.registerAsync({
            useClass: JwtConfigService
        }),
        TypeOrmModule.forFeature([UsersRepository]),
        TypeOrmModule.forFeature([ProductOffersRepository])
    ],
    controllers: [ProductOffersController],
    providers: [ProductOffersService, JwtHelper, DoSpacesService, DoSpacesServicerovider]
})

export class ProductOffersModule {}
